Subject: [FFC-dev] Re: from Numeric to scipy.core

From: Anders Logg <[email-masked]>
Date: Fri, 16 Dec 2005 10:04:59 -0600

On Thu, Dec 15, 2005 at 11:28:49AM -0600, Matthew Knepley wrote:
> Sebastian Rooks <[email-masked]> writes:
> 
> > Dear Fenics Developers,
> >
> > On the ffc mailing list, you had a thread about the Numeric to scipy.core transistion. I think there is some
> > misunderstanding on the transition process and I hope that the following information may be of some help.
> >
> >>> Good to know. So the suggestion is to stick to Numeric until it
> >>> becomes part of the Python core, or until the PEP is rejected in which
> >>> case we switch to SciPy?
> >>  Yes.
> >
> > Here is a recent mail (11 Dec 21:53) from Travis Oliphant on a scipy
> > mailing-list
> > http://article.gmane.org/gmane.comp.python.scientific.user/5798 :
> >
> > --- Begin of citation ---
> >
> > I've noticed there is some confusion still circulating on the net that
> > the new arrayobject in scipy_core is going to get into Python at some
> > point, and some people are holding off making any changes until that
> > happens.    I am probably the source of that confusion since at one time
> > I did have that goal.  However, early on (in March) after discussions
> > with Paul, Perry, and Guido we decided that trying to force an
> > arrayobject into Python would place us on a release cycle that would be
> > constraining.   So, don't wait to try out scipy_core because there is
> > nothing going into Python any time soon that is even as capable as
> > Numeric.
> 
>   This is odd, since at SciPy in Nov., I thought Travis told me the opposite
> which was he was submitting a PEP for Numeric 3. But I guess I really do not
> care if its in the core or a module, but it will be "released" on its own soon.
> 
>      Matt

Here are som further quotes from http://numeric.scipy.org/:

"Development for Numerical Python has ceased, and users should
transisition to SciPy Core as quickly as possible."

"It is the opinion of many involved that a default N-dimensional array
interface (even leading to a very simple N-dimensional array object
and an N-dimensional array protocol) is what should be pushed for
placement in the Python core.    It is doubtful that the community
will want to slow down development of SciPy Core anytime soon by
placing it the Python core.  But the array interface should become a
part of Python as soon as possible."

"The fundamental package needed for scientific computing with Python is
called scipy_core.  This package contains a powerful N-dimensional
array object, sophisticated (broadcasting) functions, tools for
integrating C/C++ and Fortran code, and useful linear algebra, Fourier
transform, and random number capabilities. It is currently in beta
release, but should be relatively stable as it derives from the old
Numeric Python code base."

This raises some further questions:

1. Will the "array interface" if included in Python core be enough for
the needs of FIAT and FFC, or will we anyway depend on SciPy?

2. Is the current latest release of SciPy stable wrt multidimensional
arrays so we could make the switch now? Or are we anyway waiting for a
stable release of SciPy before we could make a switch from Numeric?

/Anders

---

From: Matthew Knepley <[email-masked]>
Date: Fri, 16 Dec 2005 13:24:50 -0600

> the needs of FIAT and FFC, or will we anyway depend on SciPy?

  I think that the array interface should be sufficient. Now I can understand
the confusion. SciPy core will not go in the Python distro, but this should.

> stable release of SciPy before we could make a switch from Numeric?

  I think its pretty stable.

    Matt
-- 
"Failure has a thousand explanations. Success doesn't need one" -- Sir Alec Guiness

---

From: Anders Logg <[email-masked]>
Date: Mon, 19 Dec 2005 22:29:31 -0600

> the confusion. SciPy core will not go in the Python distro, but this should.

I'll try a switch to SciPy when I get the chance. Maybe it's only
little work.

/Anders

-- 
Anders Logg
Research Assistant Professor
Toyota Technological Institute at Chicago
http://www.tti-c.org/logg/